%global	ruby_sitelib		%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")

%global	gemname	gettext_activerecord
%global	gemdir		%(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global	geminstdir	%{gemdir}/gems/%{gemname}-%{version}

%global	rubyabi	1.8
%global	gettext_req	2.1.0
%global	activerecord_req	2.3.2
%global	do_check	0
%if 0%{?fedora} >= 11
%global	do_check	1
%endif
 
Summary:	Localization support for ActiveRecord by Ruby-GetText-Package
Name:		rubygem-%{gemname}
Version:	2.1.0
Release:	1%{?dist}
Group:		Development/Languages
License:	GPLv2 or Ruby
URL:		http://www.yotabanana.com/hiki/ruby-gettext-rails.html
Source0:	http://gems.rubyforge.org/gems/%{gemname}-%{version}.gem
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	ruby(rubygems)
BuildRequires:	rubygem(gettext) >= %{gettext_req}
BuildRequires:	rubygem(rake)
BuildRequires:	rubygem(activerecord) >= %{activerecord_req}
%if %{do_check}
BuildRequires(check):	rubygem(sqlite3-ruby)
BuildRequires(check):	rubygem(allison)
%endif
Requires:	ruby(abi) = %{rubyabi}
Requires:	ruby(rubygems)
Requires:	rubygem(gettext) >= %{gettext_req}
Requires:	rubygem(activerecord) >= %{activerecord_req}
BuildArch:	noarch
Provides:	rubygem(%{gemname}) = %{version}-%{release}

%description
gettext_activerecord provides the localization for ActiveRecord
using Ruby-GetText-Package.

* Validation messages translation
* Model translation
* extract messages from models with the rake task.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.


%prep
%setup -q -c -T

%build
mkdir -p .%{gemdir}
gem install \
	--local \
	--install-dir $(pwd)%{gemdir} \
	--force \
	--rdoc \
	-V \
	%{SOURCE0}

rm -f .%{geminstdir}/*.gemspec

# Recreate mo
export GEM_PATH=$(pwd)/%{gemdir}

pushd .%{geminstdir}
find . -name \*.mo | xargs rm -f
find . -name \*.rb | xargs chmod 0644
rake --trace makemo
( cd test/ ; rake --trace makemo )

popd

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* %{buildroot}%{gemdir}/

# modify find-lang.sh to deal with gettext .mo files under
# %%{geminstdir}/data/locale
sed -e 's|/share/locale/|/data/locale/|' \
	/usr/lib/rpm/find-lang.sh \
	> find-lang-modified.sh

sh find-lang-modified.sh %{buildroot} %{gemname} %{gemname}.lang
# list directories under %%{geminstdir}/data/
find %{buildroot}%{geminstdir}/data -type d | while read dir
do
	echo "%%dir ${dir#%{buildroot}}" >> %{gemname}.lang
done

# Also for %%{geminstdir}/test/locale
sed -e 's|/share/locale/|/test/locale/|' \
	/usr/lib/rpm/find-lang.sh \
	> find-lang-modified.sh
sh find-lang-modified.sh %{buildroot} active_record doc.lang
find %{buildroot}%{geminstdir}/test/locale -type d | while read dir
do
	echo "%%dir ${dir#%{buildroot}}" >> doc.lang
done

%clean
rm -rf %{buildroot}

%check
[ %{do_check} = 0 ] && exit 0
cd .%{geminstdir}

rake test

%files -f %{gemname}.lang
%defattr(-,root,root,-)

%dir %{geminstdir}
%doc %{geminstdir}/[A-Z]*
%exclude %{geminstdir}/Rakefile
%{geminstdir}/lib/
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files doc -f doc.lang
%defattr(-,root,root,-)
%{geminstdir}/Rakefile
%{gemdir}/doc/%{gemname}-%{version}/
%{geminstdir}/po/
%{geminstdir}/sample/

%dir %{geminstdir}/test/
%{geminstdir}/test/Rakefile
%{geminstdir}/test/*.rb
%{geminstdir}/test/[dm-pv-z]*/

%changelog
* Thu Nov 19 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.1.0-1
- 2.1.0

* Sat Jul 25 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-8
- F-12: Mass rebuild

* Thu Jun 25 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-7
- Add BR: rubygem(allison) for %%check

* Thu Jun 18 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-6
- Description clean up

* Tue Jun 16 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-5
- More BR: rubygem(activerecord) for recreating mo files

* Tue Jun 16 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-4
- Remove COPYING for now
- Change BR: now rubygem(rake) is needed to create gettext mo

* Mon Jun 15 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-3
- Recreate gettext mo files (BR: rubygem(gettext))
- Change BR: ruby(sqlite) -> rubygem(sqlite3-ruby)
- Some cleanups

* Fri Jun 12 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-2
- Also mark gettext mo files under test/ directory with %%lang

* Tue Jun  9 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.0.4-1
- Initial package
